## remctl 3.5

=== debian/changelog ===
remctl (3.5-1build1) saucy; urgency=low

  * Rebuild for PHP 5.5.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 16 Jul 2013 01:46:57 +0100

remctl (3.5-1) unstable; urgency=low

  * New upstream release.
    - Fix a long-standing race condition in remctld that could truncate
      large backend output.
    - remctl_set_ccache is now threadsafe when built against a GSS-API
      library that supports gss_krb5_import_cred.
    - The Net::Remctl and Net::Remctl::Backend Perl module versions have
      gone backwards from Perl's perspective to bring them in-line with
      the package version (3.4 -> 3.05).  This is a one-time adjustment
      to a more reliable versioning scheme.
    - Fix test suite issues with newer Linux kernels.

 -- Russ Allbery <rra@debian.org>  Fri, 28 Jun 2013 21:45:30 -0700

remctl (3.4-2) unstable; urgency=low

  * Upload to unstable.
  * Drop old Ruby transitional packages required for upgrades from squeeze
    now that wheezy has been released.
  * Add additional Perl modules required to run the full module test suite
    to Build-Depends.

 -- Russ Allbery <rra@debian.org>  Sat, 11 May 2013 16:34:25 -0700

remctl (3.4-1) experimental; urgency=low

  * New upstream release.
    - New C APIs for establishing a remctl connection given a sockaddr, a
      list of struct addrinfo, or an already open socket.
    - New Net::Remctl::Backend Perl module to aid writing remctl backend
      scripts.
    - Remove all prototypes from Net::Remctl functions.
    - Return an error if an empty command is passed to remctl_command.

 -- Russ Allbery <rra@debian.org>  Tue, 26 Mar 2013 13:19:58 -0700

remctl (3.3-1) experimental; urgency=low

  * New upstream release.
    - Fix a file descriptor leak when checking ACL files.
    - Fix memory leaks in remctld and libremctl.
    - Don't create the PID file in remctld until the network socket is set
      up and listening.
    - Remove prototypes from the Perl remctl() function to allow passing
      in parameters via an array.
  * Use xz compression for the Debian binary packages.
  * Update to standards version 3.9.4.
    - Add branch information to Vcs-Git.

 -- Russ Allbery <rra@debian.org>  Tue, 25 Sep 2012 21:34:43 -0700

=== debian/control ===
Source: remctl
Section: net
Priority: optional
Maintainer: Russ Allbery <rra@debian.org>
Build-Depends: debhelper (>= 9), dh-autoreconf, dpkg-dev (>= 1.14.9),
 libkrb5-dev, libpcre3-dev, libperl-critic-perl, libtest-pod-perl,
 libtest-minimumversion-perl, libtest-pod-coverage-perl,
 libtest-strict-perl, libtest-synopsis-perl, perl, php5-cli, php5-dev,
 python-all-dev, ruby1.8, ruby1.8-dev, ruby1.9.1, ruby1.9.1-dev
XS-Python-Version: >= 2.6
Standards-Version: 3.9.4
Homepage: http://www.eyrie.org/~eagle/software/remctl/
Vcs-Git: git://git.eyrie.org/kerberos/remctl.git -b debian
Vcs-Browser: http://git.eyrie.org/?p=kerberos/remctl.git

Package: libremctl1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the client libraries linked against MIT Kerberos.

Package: libremctl-dev
Section: libdevel
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libremctl1 (= ${binary:Version})
Suggests: libkrb5-dev
Description: Development files for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the development files for client libraries linked
 against MIT Kerberos.

Package: remctl-client
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Client for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the client program (remctl).

Package: remctl-server
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, update-inetd | inet-superserver,
 netbase (>= 4.31)
Recommends: openbsd-inetd | inet-superserver, tcpd
Description: Server for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the server (remctld).

Package: libnet-remctl-perl
Section: perl
Architecture: any
Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}
Description: Perl client for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the Net::Remctl Perl library, which provides native
 Perl bindings for the libremctl client library.  It also contains the
 Net::Remctl::Backend module, which assists in writing remctl backends in
 Perl.

Package: php5-remctl
Section: php
Architecture: any
Depends: ${shlibs:Depends}, ${php:Depends}, ${misc:Depends}
Description: PECL module for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the PECL remctl module for PHP 5, which provides
 native PHP bindings for the libremctl client library.

Package: python-remctl
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${python:Depends}, ${misc:Depends}
Provides: ${python:Provides}
Description: Python extension for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the Python remctl extension, which provides native
 Python bindings for the libremctl client library.

Package: ruby-remctl
Section: ruby
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libremctl-ruby1.8 (<< 3.2), libremctl-ruby1.9 (<< 3.2)
Breaks: libremctl-ruby1.8 (<< 3.2), libremctl-ruby1.9 (<< 3.2)
Description: Ruby extension for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the Ruby remctl extension, which provides native
 Ruby bindings for the libremctl client library.

=== debian/rules ===
#!/usr/bin/make -f

# Add hardening build flags.  We have to omit PIE because it breaks the Perl
# module build (and probably the other interpretors as well).
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

# Link with --as-needed so that the remctl client library doesn't inherit
# the shared library dependencies of libremctl.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# The additional flags to pass to Build.PL, picked up by the upstream build
# system.
export REMCTL_PERL_FLAGS := --installdirs vendor --create_packlist 0

# The supported Python versions and the additional Python flags, picked up
# by the upstream build system.
export REMCTL_PYTHON_INSTALL  := --install-layout=deb
export REMCTL_PYTHON_VERSIONS := $(shell pyversions -s)

%:
	dh $@ --parallel --with python2,autoreconf

override_dh_autoreconf:
	dh_autoreconf --as-needed

override_dh_auto_configure:
	dh_auto_configure --parallel -- --sysconfdir=/etc/remctl \
	    --enable-reduced-depends --enable-perl --enable-php \
	    --enable-python --enable-ruby

# For the first pass, build the Ruby 1.8 extension.  We'll go back and build
# the extension for 1.9.1.
override_dh_auto_build:
	dh_auto_build --parallel -- REMCTL_RUBY=ruby1.8

override_dh_auto_test:
	dh_auto_test --parallel -- REMCTL_RUBY=ruby1.8

# After installing the build for the default version of Ruby, go back and
# rebuild for the newer version.
override_dh_auto_install:
	dh_auto_install -- RUBYARCHDIR='$$(vendorarchdir)$$(target_prefix)'
	cd ruby && $(MAKE) distclean
	dh_auto_build --parallel -- REMCTL_RUBY=ruby1.9.1
	cd ruby && $(MAKE) install DESTDIR='$(CURDIR)/debian/tmp' \
	    RUBYARCHDIR='$$(vendorarchdir)$$(target_prefix)'

# Override install to check for missing installed files.
override_dh_install:
	dh_install --fail-missing -Xlibremctl.la

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_makeshlibs:
	dh_makeshlibs -V 'libremctl1 (>= 3.1)'

override_dh_gencontrol:
	dh_gencontrol -- -V"php:Depends=phpapi-`php-config5 --phpapi`"

override_dh_builddeb:
	dh_builddeb -- -Zxz

## remctl 3.6

=== debian/changelog ===
remctl (3.6-1b1) staging; urgency=low

  * No-change rebuild against perl 5.18

 -- Jon Severinsson <jon@severinsson.net>  Tue, 28 Jan 2014 22:38:47 +0100

remctl (3.6-1) unstable; urgency=low

  * New upstream release.
    - For client calls with a timeout, restart waiting for a non-blocking
      connect if the select call is interrupted by a signal.
    - Better Net::Remctl::Backend help formatting for commands with long
      syntax.

 -- Russ Allbery <rra@debian.org>  Wed, 14 Aug 2013 21:56:39 -0700

## remctl 3.8

=== java/Makefile ===
# Makefile for Java remctl implementation.
#
# This Makefile is not (yet) integrated with the rest of the remctl build
# system.  You will need to either edit the JDK setting below or override it
# on the command line with:
#
#     make JAVA_HOME=/path/to/jdk/directory
#
# Currently, only the Sun Java JDK is supported (1.4.2, 5, or 6).
#
# Copyright 2007 Marcus Watts <mdw@umich.edu>
# Copyright 2007, 2008
#     The Board of Trustees of the Leland Stanford Junior University
#
# See LICENSE for licensing terms.

JAVA_HOME ?= /usr/lib/jvm/java-6-sun
JAVAC      = $(JDK)/bin/javac
JAR        = $(JDK)/bin/jar

ORIGIN     = org/eyrie/eagle/remctl
SOURCE     = $(ORIGIN)/RemctlClient.java $(ORIGIN)/RemctlServer.java \
	     $(ORIGIN)/Remctl.java
CLASS	   = $(SOURCE:.java=.class)

all: remctl.jar t5.class t7.class

t5.class: t5.java $(CLASS)
	$(JAVAC) -g t5.java

t7.class: t7.java $(CLASS)
	$(JAVAC) -g t7.java

remctl.jar: $(CLASS)
	$(JAR) cfe remctl.jar $(ORIGIN)/RemctlClient $(ORIGIN)/*.class

$(ORIGIN)/RemctlClient.class: $(ORIGIN)/RemctlClient.java $(ORIGIN)/Remctl.class
	$(JAVAC) -g $(ORIGIN)/RemctlClient.java

$(ORIGIN)/RemctlServer.class: $(ORIGIN)/RemctlServer.java $(ORIGIN)/Remctl.class
	$(JAVAC) -g $(ORIGIN)/RemctlServer.java

$(ORIGIN)/Remctl.class: $(ORIGIN)/Remctl.java
	$(JAVAC) -g $(ORIGIN)/Remctl.java

clean:
	rm -rf $(ORIGIN)/*.class remctl.jar *.class

=== debian/changelog ===
remctl (3.8-3) unstable; urgency=medium

  * Build-Depend on the version of gem2deb with working multi-binary
    package support for native extensions.
  * Fix the exclusion rule for dh_install --fail-missing to ignore the
    Ruby module under both the 2.0 and 1.9.1 paths.  (dh_ruby --install
    will go back and install the module in the correct locations.)  Should
    fix FTBFS in Ubuntu, which still has Ruby 1.9.1.

 -- Russ Allbery <rra@debian.org>  Fri, 11 Apr 2014 13:27:58 -0700

remctl (3.8-2) unstable; urgency=medium

  * Add upstream patch to increase the buffer size on timeout tests.
    Linux has apparently increased the size of network writes it is
    willing to buffer internally, so we now have to write more data to
    force a timeout.  (Closes: #743991)
  * Use gem2deb to build and install the Ruby module.  This will
    automatically use the current supported Ruby versions, avoiding the
    need for sourceful uploads for new Ruby releases.  Thanks to Christian
    Hofstaedtler for the patch.
  * Remove now-unneeded Lintian override for the upstream signing key.
  * Add a Lintian override for the dual-licensed protocol specification.

 -- Russ Allbery <rra@debian.org>  Tue, 08 Apr 2014 19:34:24 -0700

remctl (3.8-1) unstable; urgency=medium

  * New upstream release.
    - remctld now uses libevent for the process event loop, which removes
      the need to poll for child exit and will make the server faster and
      more responsive.
    - Fill each MESSAGE_OUTPUT message from the server with the maximum
      allowed data per the protocol, rather than capping it artificially
      at 65000 octets.
    - Fix a minor server memory leak when processing help commands.
    - Fix a minor client memory leak on errors with protocol one commands.
    - Write out the server PID file atomically.
  * Start building the Ruby extension for Ruby 2.0 and stop building it
    for Ruby 1.8, which is being removed.  (Closes: #735659)
  * Add Depends on ruby | ruby-interpreter to ruby-remctl.  This is
    apparently standard for Ruby extensions, since it will pull in a
    version of Ruby that can use the extension if the Ruby versions of the
    extension match the providers of ruby-interpreter.
  * Drop Replaces and Breaks on libremctl-ruby1.8 and libremctl-ruby1.9.
    These were already tranditional packages in wheezy.
  * Correctly qualify the libsystemd-daemon-dev dependency with
    [linux-any].  (Closes: #736578)
  * Switch to the new uscan upstream signature verification method, which
    uses an armored key in debian/upstream/signing-key.asc.  This allows
    removal of debian/source/include-binaries.  Export a minimal key to
    save all the space required by key signatures, since inclusion of the
    key in the package already indicates the relevant trust and the
    signatures are retrievable from a public keyserver.

 -- Russ Allbery <rra@debian.org>  Tue, 28 Jan 2014 19:50:20 -0800

remctl (3.7-1) unstable; urgency=medium

  * New upstream release.
    - Fix client memory leak when remctl_set_ccache is used.
    - Fix Net::Remctl::Backend argument count validation when one of the
      arguments is coming from standard input.
    - remctld in stand-alone mode now supports systemd status notification
      and socket activation and, with -Z, upstart status notification.  By
      default, remctld is still spawned from inetd, so this only affects
      users who change the default configuration.  Sample systemd and
      upstart configurations are included in /usr/share/doc/remctl-server.
    - Net::Remctl classes now fail cleanly if the object is undef.
  * Switch the default Ruby build to 1.9.1 to make it easier to remove the
    Ruby 1.8 module build when ready to do so.
  * Add necessary keyring and watch configuration for uscan to verify
    PGP signatures on new upstream releases.
  * Update the watch file to download *.tar.xz distributions by default.
  * Remove now-unnecessary override of dh_builddeb to use xz compression.
  * Remove old NEWS file that predated the package split for a port
    transition that substantially predated oldstable.
  * Update standards version to 3.9.5 (no changes required).

 -- Russ Allbery <rra@debian.org>  Mon, 06 Jan 2014 15:03:12 -0800

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,28 @@
 Section: net
 Priority: optional
 Maintainer: Russ Allbery <rra@debian.org>
-Build-Depends: debhelper (>= 9), dh-autoreconf, dpkg-dev (>= 1.14.9),
- libkrb5-dev, libpcre3-dev, libperl-critic-perl, libtest-pod-perl,
- libtest-minimumversion-perl, libtest-pod-coverage-perl,
- libtest-strict-perl, libtest-synopsis-perl, perl, php5-cli, php5-dev,
- python-all-dev, ruby1.8, ruby1.8-dev, ruby1.9.1, ruby1.9.1-dev
+Build-Depends: debhelper (>= 9),
+ dh-autoreconf,
+ dpkg-dev (>= 1.14.9),
+ gem2deb (>= 0.4.1~),
+ libevent-dev,
+ libkrb5-dev,
+ libpcre3-dev,
+ libperl-critic-perl,
+ libsystemd-daemon-dev [linux-any],
+ libtest-pod-perl,
+ libtest-minimumversion-perl,
+ libtest-pod-coverage-perl,
+ libtest-strict-perl,
+ libtest-synopsis-perl,
+ perl,
+ php5-cli,
+ php5-dev,
+ pkg-config,
+ python-all-dev
 XS-Python-Version: >= 2.6
-Standards-Version: 3.9.4
+XS-Ruby-Versions: all
+Standards-Version: 3.9.5
 Homepage: http://www.eyrie.org/~eagle/software/remctl/
 Vcs-Git: git://git.eyrie.org/kerberos/remctl.git -b debian
 Vcs-Browser: http://git.eyrie.org/?p=kerberos/remctl.git
@@ -128,9 +143,10 @@
 Package: ruby-remctl
 Section: ruby
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Replaces: libremctl-ruby1.8 (<< 3.2), libremctl-ruby1.9 (<< 3.2)
-Breaks: libremctl-ruby1.8 (<< 3.2), libremctl-ruby1.9 (<< 3.2)
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, ruby | ruby-interpreter
+X-DhRuby-Root: ruby
+XB-Ruby-Versions: ${ruby:Versions}
 Description: Ruby extension for Kerberos-authenticated command execution
  remctl is a client/server protocol for executing specific commands on a
  remote system with Kerberos authentication.  The allowable commands must

=== debian/rules ===
#!/usr/bin/make -f

# Add hardening build flags.  We have to omit PIE because it breaks the Perl
# module build (and probably the other interpretors as well).
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

# Link with --as-needed so that the remctl client library doesn't inherit
# the shared library dependencies of libremctl.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# The additional flags to pass to Build.PL, picked up by the upstream build
# system.
export REMCTL_PERL_FLAGS := --installdirs vendor --create_packlist 0

# The supported Python versions and the additional Python flags, picked up
# by the upstream build system.
export REMCTL_PYTHON_INSTALL  := --install-layout=deb
export REMCTL_PYTHON_VERSIONS := $(shell pyversions -s)

%:
	dh $@ --parallel --with python2,autoreconf,ruby

override_dh_autoreconf:
	dh_autoreconf --as-needed

override_dh_auto_configure:
	dh_auto_configure --parallel -- --sysconfdir=/etc/remctl	\
	    --with-systemdsystemunitdir=/lib/systemd/system		\
	    --enable-reduced-depends --enable-perl --enable-php		\
	    --enable-python --enable-ruby

# Override install to check for missing installed files.  Ignore the Ruby
# module installed in usr/local/lib by the upstream build system.  Run
# dh_ruby --install to build and install the module for each supported Ruby
# version.
override_dh_install:
	dh_install --fail-missing -Xlibremctl.la -Xusr/local/lib
	dh_ruby --install

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_makeshlibs:
	dh_makeshlibs -V 'libremctl1 (>= 3.1)'

override_dh_gencontrol:
	dh_gencontrol -- -V"php:Depends=phpapi-`php-config5 --phpapi`"

## remctl 3.9

=== debian/changelog ===
remctl (3.9-1~bpo70+1) wheezy-backports; urgency=low

  * Backport to wheezy.
  * Restore Ruby 1.8 build and drop Ruby 2.0 build.

 -- Russ Allbery <rra@debian.org>  Sun, 13 Jul 2014 22:04:12 -0700

remctl (3.9-1) unstable; urgency=medium

  * New upstream release.
    - New server ACL type, localgroup, which converts the principal to a
      local username and then checks for membership in a local group.
    - Fix incorrect handling of interruptions of network writes by signals
      in the server.
    - Prefer calloc and reallocarray when allocating memory with
      multiplication.
    - Restore the SIGPIPE handler before running a command.
    - Add version and compatibility information to all manual pages.
  * Use an executable debian/libnet-remctl-perl.install file to pull the
    correct Perl arch-specific vendor module path from Perl during the
    build.  Should fix builds with Perl 5.20.  Thanks, Niko Tyni and
    gregor herrmann.  (Closes: #752902)
  * Build-Depend on krb5-config to get enough of a Kerberos configuration
    for some test cases that are KDC-independent to run.
  * Fix Upstream-Contact email address in debian/copyright.
  * Remove most debian/tmp prefixes from debhelper *.install files.  These
    have not been needed since compat level 7.  Retain them only for the
    remctl-server.install file, which pulls files from both the source
    tree and the installed binary tree and benefits from the
    disambiguation.

 -- Russ Allbery <rra@debian.org>  Wed, 02 Jul 2014 20:57:10 -0700

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper (>= 9),
  dh-autoreconf,
  dpkg-dev (>= 1.14.9),
- gem2deb (>= 0.4.1~),
+ krb5-config,
  libevent-dev,
  libkrb5-dev,
  libpcre3-dev,
@@ -20,9 +20,12 @@
  php5-cli,
  php5-dev,
  pkg-config,
- python-all-dev
+ python-all-dev,
+ ruby1.8,
+ ruby1.8-dev,
+ ruby1.9.1,
+ ruby1.9.1-dev
 XS-Python-Version: >= 2.6
-XS-Ruby-Versions: all
 Standards-Version: 3.9.5
 Homepage: http://www.eyrie.org/~eagle/software/remctl/
 Vcs-Git: git://git.eyrie.org/kerberos/remctl.git -b debian
@@ -143,10 +146,7 @@
 Package: ruby-remctl
 Section: ruby
 Architecture: any
-Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, ruby | ruby-interpreter
-X-DhRuby-Root: ruby
-XB-Ruby-Versions: ${ruby:Versions}
 Description: Ruby extension for Kerberos-authenticated command execution
  remctl is a client/server protocol for executing specific commands on a
  remote system with Kerberos authentication.  The allowable commands must

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,7 @@
 export REMCTL_PYTHON_VERSIONS := $(shell pyversions -s)
 
 %:
-	dh $@ --parallel --with python2,autoreconf,ruby
+	dh $@ --parallel --with python2,autoreconf
 
 override_dh_autoreconf:
 	dh_autoreconf --as-needed
@@ -29,13 +29,26 @@
 	    --enable-reduced-depends --enable-perl --enable-php		\
 	    --enable-python --enable-ruby
 
-# Override install to check for missing installed files.  Ignore the Ruby
-# module installed in usr/local/lib by the upstream build system.  Run
-# dh_ruby --install to build and install the module for each supported Ruby
-# version.
+# For the first pass, build the Ruby 1.9.1 extension.  We'll go back and
+# build the extension for 1.8.
+override_dh_auto_build:
+	dh_auto_build --parallel -- REMCTL_RUBY=ruby1.9.1
+
+override_dh_auto_test:
+	dh_auto_test --parallel -- REMCTL_RUBY=ruby1.9.1
+
+# After installing the build for the default version of Ruby, go back and
+# rebuild for the older version.
+override_dh_auto_install:
+	dh_auto_install -- RUBYARCHDIR='$$(vendorarchdir)$$(target_prefix)'
+	cd ruby && $(MAKE) distclean
+	dh_auto_build --parallel -- REMCTL_RUBY=ruby1.8
+	cd ruby && $(MAKE) install DESTDIR='$(CURDIR)/debian/tmp' \
+	    RUBYARCHDIR='$$(vendorarchdir)$$(target_prefix)'
+
+# Override install to check for missing installed files.
 override_dh_install:
-	dh_install --fail-missing -Xlibremctl.la -Xusr/local/lib
-	dh_ruby --install
+	dh_install --fail-missing -Xlibremctl.la
 
 override_dh_installchangelogs:
 	dh_installchangelogs NEWS

## remctl 3.10

=== debian/changelog ===
remctl (3.10-1ubuntu1) xenial; urgency=medium

  * Stop building php5-remctl, fails to build with php7.0.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 15 Mar 2016 10:29:47 +0100

remctl (3.10-1build2) xenial; urgency=medium

  * No-change rebuild to add ruby2.3 support.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 13 Mar 2016 12:34:53 +0000

remctl (3.10-1build1) xenial; urgency=medium

  * Rebuild for Perl 5.22.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 18 Dec 2015 10:43:39 +0000

remctl (3.10-1) unstable; urgency=medium

  * New upstream release.
    - New server ACLs anyuser:auth and anyuser:anonymous.  The latter
      allows access by anonymous clients if the KDC supports anonymous
      service tickets.
    - Server now sets the REMOTE_EXPIRES environment variable to the time
      when the client credentials would expire.
    - Anonymous users no longer satisfy ANYUSER (anyuser:auth).
    - Simplify the Python RemctlError class (with some backward
      incompatibilities).
    - Dynamically resize the buffer used for the localgroup ACL scheme,
      allowing support of users in large numbers of local groups.

 -- Russ Allbery <rra@debian.org>  Fri, 27 Nov 2015 15:24:56 -0800

remctl (3.9-2) unstable; urgency=medium

  * Build against libsystemd instead of libsystemd-daemon.  Thanks,
    Michael Biebl.  (Closes: #779764)
  * Add explicit build dependency on libmodule-build-perl, since it will
    soon no longer be provided by the perl package.  (Closes: #791666)
  * Add debian/gbp.conf reflecting the branch layout of the default
    packaging repository.
  * Refresh upstream signing key.
  * Update standards version to 3.9.6 (no changes required).

 -- Russ Allbery <rra@debian.org>  Sat, 08 Aug 2015 11:16:49 -0700

=== debian/control ===
--- 
+++ 
@@ -5,28 +5,27 @@
 Build-Depends: debhelper (>= 9),
  dh-autoreconf,
  dpkg-dev (>= 1.14.9),
+ gem2deb (>= 0.4.1~),
  krb5-config,
  libevent-dev,
  libkrb5-dev,
+ libmodule-build-perl,
  libpcre3-dev,
  libperl-critic-perl,
- libsystemd-daemon-dev [linux-any],
+ libsystemd-dev [linux-any],
  libtest-pod-perl,
  libtest-minimumversion-perl,
  libtest-pod-coverage-perl,
  libtest-strict-perl,
  libtest-synopsis-perl,
  perl,
- php5-cli,
- php5-dev,
+# php5-cli,
+# php5-dev,
  pkg-config,
- python-all-dev,
- ruby1.8,
- ruby1.8-dev,
- ruby1.9.1,
- ruby1.9.1-dev
+ python-all-dev
 XS-Python-Version: >= 2.6
-Standards-Version: 3.9.5
+XS-Ruby-Versions: all
+Standards-Version: 3.9.6
 Homepage: http://www.eyrie.org/~eagle/software/remctl/
 Vcs-Git: git://git.eyrie.org/kerberos/remctl.git -b debian
 Vcs-Browser: http://git.eyrie.org/?p=kerberos/remctl.git
@@ -112,20 +111,20 @@
  Net::Remctl::Backend module, which assists in writing remctl backends in
  Perl.
 
-Package: php5-remctl
-Section: php
-Architecture: any
-Depends: ${shlibs:Depends}, ${php:Depends}, ${misc:Depends}
-Description: PECL module for Kerberos-authenticated command execution
- remctl is a client/server protocol for executing specific commands on a
- remote system with Kerberos authentication.  The allowable commands must
- be listed in a server configuration file, and the executable run on the
- server may be mapped to any command name.  Each command is also
- associated with an ACL containing a list of Kerberos principals
- authorized to run that command.
- .
- This package contains the PECL remctl module for PHP 5, which provides
- native PHP bindings for the libremctl client library.
+#Package: php5-remctl
+#Section: php
+#Architecture: any
+#Depends: ${shlibs:Depends}, ${php:Depends}, ${misc:Depends}
+#Description: PECL module for Kerberos-authenticated command execution
+# remctl is a client/server protocol for executing specific commands on a
+# remote system with Kerberos authentication.  The allowable commands must
+# be listed in a server configuration file, and the executable run on the
+# server may be mapped to any command name.  Each command is also
+# associated with an ACL containing a list of Kerberos principals
+# authorized to run that command.
+# .
+# This package contains the PECL remctl module for PHP 5, which provides
+# native PHP bindings for the libremctl client library.
 
 Package: python-remctl
 Section: python
@@ -146,7 +145,10 @@
 Package: ruby-remctl
 Section: ruby
 Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, ruby | ruby-interpreter
+X-DhRuby-Root: ruby
+XB-Ruby-Versions: ${ruby:Versions}
 Description: Ruby extension for Kerberos-authenticated command execution
  remctl is a client/server protocol for executing specific commands on a
  remote system with Kerberos authentication.  The allowable commands must

=== debian/rules ===
#!/usr/bin/make -f

# Add hardening build flags.  We have to omit PIE because it breaks the Perl
# module build (and probably the other interpretors as well).
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

# Link with --as-needed so that the remctl client library doesn't inherit
# the shared library dependencies of libremctl.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# The additional flags to pass to Build.PL, picked up by the upstream build
# system.
export REMCTL_PERL_FLAGS := --installdirs vendor --create_packlist 0

# The supported Python versions and the additional Python flags, picked up
# by the upstream build system.
export REMCTL_PYTHON_INSTALL  := --install-layout=deb
export REMCTL_PYTHON_VERSIONS := $(shell pyversions -s)

%:
	dh $@ --parallel --with python2,autoreconf,ruby

override_dh_autoreconf:
	dh_autoreconf --as-needed

override_dh_auto_configure:
	dh_auto_configure --parallel -- --sysconfdir=/etc/remctl	\
	    --with-systemdsystemunitdir=/lib/systemd/system		\
	    --enable-reduced-depends --enable-perl --disable-php		\
	    --enable-python --enable-ruby

# Override install to check for missing installed files.  Ignore the Ruby
# module installed in usr/local/lib by the upstream build system.  Run
# dh_ruby --install to build and install the module for each supported Ruby
# version.
override_dh_install:
	dh_install --fail-missing -Xlibremctl.la -Xusr/local/lib
	dh_ruby --install

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_makeshlibs:
	dh_makeshlibs -V 'libremctl1 (>= 3.1)'

#override_dh_gencontrol:
#	dh_gencontrol -- -V"php:Depends=phpapi-`php-config5 --phpapi`"

## remctl 3.11

=== debian/changelog ===
remctl (3.11-1) unstable; urgency=medium

  * New upstream release.
    - Port to PHP 7.  (Closes: #821713)
  * Convert packaging to use dh_php and build php-remctl instead of
    php5-remctl (and provide php7.0-remctl).  There is no upgrade path
    defined from php5-remctl, since that seems to be the way other PHP
    packages are being handled during the upgrade.
  * Switch to the DEP-14 branch layout and update debian/gbp.conf and
    Vcs-Git accordingly.
  * Belatedly bump shlibs for interfaces added in remctl 3.3.

 -- Russ Allbery <rra@debian.org>  Sat, 07 May 2016 15:15:46 -0700

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Russ Allbery <rra@debian.org>
 Build-Depends: debhelper (>= 9),
  dh-autoreconf,
+ dh-php,
  dpkg-dev (>= 1.14.9),
  gem2deb (>= 0.4.1~),
  krb5-config,
@@ -19,15 +20,15 @@
  libtest-strict-perl,
  libtest-synopsis-perl,
  perl,
-# php5-cli,
-# php5-dev,
+ php-cli,
+ php-dev,
  pkg-config,
  python-all-dev
 XS-Python-Version: >= 2.6
 XS-Ruby-Versions: all
 Standards-Version: 3.9.6
 Homepage: http://www.eyrie.org/~eagle/software/remctl/
-Vcs-Git: git://git.eyrie.org/kerberos/remctl.git -b debian
+Vcs-Git: git://git.eyrie.org/kerberos/remctl.git -b debian/master
 Vcs-Browser: http://git.eyrie.org/?p=kerberos/remctl.git
 
 Package: libremctl1
@@ -111,20 +112,21 @@
  Net::Remctl::Backend module, which assists in writing remctl backends in
  Perl.
 
-#Package: php5-remctl
-#Section: php
-#Architecture: any
-#Depends: ${shlibs:Depends}, ${php:Depends}, ${misc:Depends}
-#Description: PECL module for Kerberos-authenticated command execution
-# remctl is a client/server protocol for executing specific commands on a
-# remote system with Kerberos authentication.  The allowable commands must
-# be listed in a server configuration file, and the executable run on the
-# server may be mapped to any command name.  Each command is also
-# associated with an ACL containing a list of Kerberos principals
-# authorized to run that command.
-# .
-# This package contains the PECL remctl module for PHP 5, which provides
-# native PHP bindings for the libremctl client library.
+Package: php-remctl
+Section: php
+Architecture: any
+Depends: ${shlibs:Depends}, ${php:Depends}, ${misc:Depends}
+Provides: php7.0-remctl
+Description: PECL module for Kerberos-authenticated command execution
+ remctl is a client/server protocol for executing specific commands on a
+ remote system with Kerberos authentication.  The allowable commands must
+ be listed in a server configuration file, and the executable run on the
+ server may be mapped to any command name.  Each command is also
+ associated with an ACL containing a list of Kerberos principals
+ authorized to run that command.
+ .
+ This package contains the PECL remctl module for PHP 7, which provides
+ native PHP bindings for the libremctl client library.
 
 Package: python-remctl
 Section: python

=== debian/rules ===
--- 
+++ 
@@ -26,7 +26,7 @@
 override_dh_auto_configure:
 	dh_auto_configure --parallel -- --sysconfdir=/etc/remctl	\
 	    --with-systemdsystemunitdir=/lib/systemd/system		\
-	    --enable-reduced-depends --enable-perl --disable-php		\
+	    --enable-reduced-depends --enable-perl --enable-php		\
 	    --enable-python --enable-ruby
 
 # Override install to check for missing installed files.  Ignore the Ruby
@@ -36,12 +36,10 @@
 override_dh_install:
 	dh_install --fail-missing -Xlibremctl.la -Xusr/local/lib
 	dh_ruby --install
+	dh_php -pphp-remctl
 
 override_dh_installchangelogs:
 	dh_installchangelogs NEWS
 
 override_dh_makeshlibs:
-	dh_makeshlibs -V 'libremctl1 (>= 3.1)'
-
-#override_dh_gencontrol:
-#	dh_gencontrol -- -V"php:Depends=phpapi-`php-config5 --phpapi`"
+	dh_makeshlibs -V 'libremctl1 (>= 3.3)'

## remctl 3.12

=== debian/changelog ===
remctl (3.12-1) unstable; urgency=medium

  * New upstream release.
    - New server implementation, remctl-shell, included in the
      remctl-server package, which is meant to be run as the shell of a
      dedicated user via ssh and supports the same configuration as
      remctld.  (This may eventually move into a separate package; if you
      would like to see that, file a bug.)
    - New server configuration option, sudo, which says to change users
      with sudo when running the command.
  * Hard-code the path to sudo in the build so that the sudo package
    doesn't have to be installed when building the package.
  * Switch to the new comment character for php-remctl.ini.
  * Switch to https for all package metadata URLs.
  * Remove now-unneeded source Lintian override.
  * Update standards version to 3.9.8 (no changes required).

 -- Russ Allbery <rra@debian.org>  Fri, 29 Jul 2016 13:23:57 -0700

=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,8 @@
 	dh_autoreconf --as-needed
 
 override_dh_auto_configure:
-	dh_auto_configure --parallel -- --sysconfdir=/etc/remctl	\
+	dh_auto_configure --parallel -- PATH_SUDO=/usr/bin/sudo		\
+	    --sysconfdir=/etc/remctl					\
 	    --with-systemdsystemunitdir=/lib/systemd/system		\
 	    --enable-reduced-depends --enable-perl --enable-php		\
 	    --enable-python --enable-ruby

## remctl 3.13

=== debian/control ===
--- 
+++ 
@@ -26,10 +26,10 @@
  python-all-dev
 XS-Python-Version: >= 2.6
 XS-Ruby-Versions: all
-Standards-Version: 3.9.6
-Homepage: http://www.eyrie.org/~eagle/software/remctl/
-Vcs-Git: git://git.eyrie.org/kerberos/remctl.git -b debian/master
-Vcs-Browser: http://git.eyrie.org/?p=kerberos/remctl.git
+Standards-Version: 3.9.8
+Homepage: https://www.eyrie.org/~eagle/software/remctl/
+Vcs-Git: https://git.eyrie.org/git/kerberos/remctl.git -b debian/master
+Vcs-Browser: https://git.eyrie.org/?p=kerberos/remctl.git
 
 Package: libremctl1
 Section: libs

=== debian/rules ===
--- 
+++ 
@@ -1,12 +1,17 @@
 #!/usr/bin/make -f
 
-# Add hardening build flags.  We have to omit PIE because it breaks the Perl
-# module build (and probably the other interpretors as well).
+# Add hardening build flags.  -fPIE is added separately below via hooks in
+# the upstream build system, since adding it globally breaks the language
+# binding modules.
 export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 
 # Link with --as-needed so that the remctl client library doesn't inherit
 # the shared library dependencies of libremctl.
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+
+# Enable -fPIE for all binaries, picked up by the upstream build system.
+export REMCTL_PROGRAM_CFLAGS  = -fPIE
+export REMCTL_PROGRAM_LDFLAGS = -fPIE
 
 # The additional flags to pass to Build.PL, picked up by the upstream build
 # system.

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
    http://archives.eyrie.org/software/kerberos/remctl-(.*)\.tar\.xz

## remctl 3.15

=== debian/changelog ===
remctl (3.15-1) unstable; urgency=medium

  * New upstream release.
    - Fix possible output truncation for commands receiving data from
      standard input that exit before reading all input data.
    - Do more paranoid validation of more protocol elements.
    - Make a test robust against the first resolved value of 127.0.0.1 not
      being localhost.  (Closes: #835677)
  * Add Multi-Arch: same for libnet-remctl-perl and ruby-remctl.
  * Enable basic pkg-perl-autopkgtests tests with a custom control file,
    since autodep8 doesn't find the Perl package built from this
    more-complex source package.  Don't include the smoke test for now
    since it requires a more complex setup and execution of the test from
    the perl subdirectory.
  * Add the Python import test generated by autodep8 to the package.
    (Unfortunately, autopkgtest-pkg-python in the Testsuite control field
    appears to do nothing if debian/tests/control exists in the package.)
  * Add dh-python to Build-Depends as requested by dh_python2.
  * Add debian/upstream/metadata file.
  * Set Rules-Requires-Root: no.
  * Bump watch file version to 4.
  * Update standards version to 4.1.4 (no changes required).

 -- Russ Allbery <rra@debian.org>  Sat, 05 May 2018 15:30:47 -0700

remctl (3.14-1) unstable; urgency=high

  * New upstream release.
    - SECURITY: Fix use-after-free and double-free when handling the sudo
      option in remctld.  This may allow (with some difficulty) arbitrary
      command execution on the server by streaming clients if the sudo
      option was used in the server configuration.  Thanks, Santosh
      Ananthakrishnan.  (CVE-2018-0493)
  * Add upstream-vcs-tag pattern to debian/gbp.conf.
  * Use an https URL in debian/watch.
  * Update debhelper comptibility level to V11.
    - Drop dependency and explicit configuration of dh-autoreconf.
    - Drop explicit --parallel option, since this is now the default.
  * Update standards version to 4.1.3.
    - Change libremctl-dev priority to optional.
    - Use https URLs in debian/copyright.
  * Refresh upstream signing key.

 -- Russ Allbery <rra@debian.org>  Sun, 01 Apr 2018 15:07:40 -0700

remctl (3.13-1) unstable; urgency=medium

  * New upstream release.
    - remctl-shell now supports being run as a forced command.
    - The summary configuration option is now allowed for commands with
      subcommands other than ALL, passing in two arguments to the summary
      command.
  * Build the standalone binaries with -fPIE.

 -- Russ Allbery <rra@debian.org>  Mon, 10 Oct 2016 19:23:31 -0700

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: net
 Priority: optional
 Maintainer: Russ Allbery <rra@debian.org>
-Build-Depends: debhelper (>= 9),
- dh-autoreconf,
+Build-Depends: debhelper (>= 11),
  dh-php,
+ dh-python,
  dpkg-dev (>= 1.14.9),
  gem2deb (>= 0.4.1~),
  krb5-config,
@@ -26,7 +26,8 @@
  python-all-dev
 XS-Python-Version: >= 2.6
 XS-Ruby-Versions: all
-Standards-Version: 3.9.8
+Rules-Requires-Root: no
+Standards-Version: 4.1.4
 Homepage: https://www.eyrie.org/~eagle/software/remctl/
 Vcs-Git: https://git.eyrie.org/git/kerberos/remctl.git -b debian/master
 Vcs-Browser: https://git.eyrie.org/?p=kerberos/remctl.git
@@ -49,7 +50,6 @@
 
 Package: libremctl-dev
 Section: libdevel
-Priority: extra
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, libremctl1 (= ${binary:Version})
@@ -98,6 +98,7 @@
 Package: libnet-remctl-perl
 Section: perl
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}
 Description: Perl client for Kerberos-authenticated command execution
  remctl is a client/server protocol for executing specific commands on a
@@ -147,6 +148,7 @@
 Package: ruby-remctl
 Section: ruby
 Architecture: any
+Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, ruby | ruby-interpreter
 X-DhRuby-Root: ruby

=== debian/rules ===
--- 
+++ 
@@ -23,16 +23,15 @@
 export REMCTL_PYTHON_VERSIONS := $(shell pyversions -s)
 
 %:
-	dh $@ --parallel --with python2,autoreconf,ruby
+	dh $@ --with python2,ruby
 
 override_dh_autoreconf:
 	dh_autoreconf --as-needed
 
 override_dh_auto_configure:
-	dh_auto_configure --parallel -- PATH_SUDO=/usr/bin/sudo		\
-	    --sysconfdir=/etc/remctl					\
-	    --with-systemdsystemunitdir=/lib/systemd/system		\
-	    --enable-reduced-depends --enable-perl --enable-php		\
+	dh_auto_configure -- PATH_SUDO=/usr/bin/sudo --sysconfdir=/etc/remctl \
+	    --with-systemdsystemunitdir=/lib/systemd/system		      \
+	    --enable-reduced-depends --enable-perl --enable-php		      \
 	    --enable-python --enable-ruby
 
 # Override install to check for missing installed files.  Ignore the Ruby

=== debian/tests/control ===
Test-Command: /usr/share/pkg-perl-autopkgtest/runner runtime-deps
Depends: @, pkg-perl-autopkgtest

Test-Command: /usr/share/pkg-perl-autopkgtest/runner runtime-deps-and-recommends
Depends: @, pkg-perl-autopkgtest
Restrictions: needs-recommends

# This unfortunately has to be manually specified since if tests/control
# exists, autopkgtest apparently no longer runs autodep8.
Tests: python
Depends: python-all, python-remctl
